import { DeepPartial } from '@azure-tools/codegen';
import { Expression, ExpressionOrLiteral } from '../expression';
import { StatementPossibilities, Statements } from './statement';
import { TypeDeclaration } from '../type-declaration';
export declare class IfStatement extends Statements {
    private conditional;
    constructor(conditional: ExpressionOrLiteral, statements: StatementPossibilities, objectInitializer?: DeepPartial<IfStatement>);
    get implementation(): string;
}
export declare class WhileStatement extends Statements {
    conditional: Expression;
    constructor(conditional: ExpressionOrLiteral, statements: StatementPossibilities, objectInitializer?: DeepPartial<IfStatement>);
    get implementation(): string;
}
export declare class DoWhileStatement extends Statements {
    conditional: Expression;
    constructor(conditional: ExpressionOrLiteral, statements: StatementPossibilities, objectInitializer?: DeepPartial<DoWhileStatement>);
    get implementation(): string;
}
export declare class ElseIfStatement extends Statements {
    conditional: Expression;
    constructor(conditional: ExpressionOrLiteral, statements: StatementPossibilities, objectInitializer?: DeepPartial<IfStatement>);
    get implementation(): string;
}
export declare function ElseIf(conditional: ExpressionOrLiteral, statements: StatementPossibilities, objectInitializer?: DeepPartial<IfStatement>): ElseIfStatement;
export declare class ElseStatement extends Statements {
    constructor(statements: StatementPossibilities, objectInitializer?: DeepPartial<IfStatement>);
    get implementation(): string;
}
export declare function Not(conditional: Expression): Expression;
export declare function IsAssignableFrom(targetType: TypeDeclaration, instanceType: ExpressionOrLiteral): Expression;
export declare function If(conditional: ExpressionOrLiteral, statements: StatementPossibilities, objectInitializer?: DeepPartial<IfStatement>): IfStatement;
export declare function Else(statements: StatementPossibilities, objectInitializer?: DeepPartial<ElseStatement>): ElseStatement;
export declare function DoWhile(conditional: ExpressionOrLiteral, statements: StatementPossibilities, objectInitializer?: DeepPartial<DoWhileStatement>): DoWhileStatement;
export declare function While(conditional: ExpressionOrLiteral, statements: StatementPossibilities, objectInitializer?: DeepPartial<IfStatement>): WhileStatement;
//# sourceMappingURL=if.d.ts.map